'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_OPTIONS = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash.defaultsdeep');

var _lodash2 = _interopRequireDefault(_lodash);

var _shouldInclude = require('./addons/should-include');

var _shouldInclude2 = _interopRequireDefault(_shouldInclude);

var _notifyIncluded = require('./addons/notify-included');

var _notifyIncluded2 = _interopRequireDefault(_notifyIncluded);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DEFAULT_OPTIONS = exports.DEFAULT_OPTIONS = {
  targets: {
    browsers: ['last 2 versions']
  }
};

var AbstractBuild = function () {
  function AbstractBuild(defaults, options) {
    _classCallCheck(this, AbstractBuild);

    defaults = defaults || {};
    options = options || {};
    var missingProjectMessage = 'You must pass through the default arguments passed into your ember-cli-build.js file.';

    if (arguments.length === 0) {
      throw new Error(missingProjectMessage);
    }

    if (!defaults.project) {
      throw new Error(missingProjectMessage);
    }

    this.options = (0, _lodash2.default)(options, defaults);
    this.project = options.project;
    this.env = options.project.env;
    this.isProduction = this.env === 'production';
  }

  _createClass(AbstractBuild, [{
    key: 'initializeAddons',
    value: function initializeAddons() {
      this.project.initializeAddons();
    }
  }, {
    key: 'dependencies',
    value: function dependencies(pkg) {
      return this.project.dependencies(pkg);
    }
  }, {
    key: '_notifyAddonIncluded',
    value: function _notifyAddonIncluded() {
      var _this = this;

      this.initializeAddons();
      var _options$addons = this.options.addons,
          blacklist = _options$addons.blacklist,
          whitelist = _options$addons.whitelist;

      (0, _notifyIncluded2.default)(this.project, blacklist, whitelist, function (addon) {
        addon.app = _this;

        if ((0, _shouldInclude2.default)(addon, blacklist, whitelist)) {
          if (addon.included) {
            addon.included(_this);
          }

          return addon;
        }
      });
    }
  }, {
    key: 'typeScriptTree',
    value: function typeScriptTree() {}
  }, {
    key: 'esLatestTree',
    value: function esLatestTree() {
      throw new Error('Must implement');
    }
  }, {
    key: 'esTree',
    value: function esTree() {
      throw new Error('Must implement');
    }
  }, {
    key: 'package',
    value: function _package() {
      throw new Error('Must implement');
    }
  }]);

  return AbstractBuild;
}();

exports.default = AbstractBuild;