"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _notifyAddonIncluded;
function _notifyAddonIncluded(project, blacklist, whitelist, notiferFn) {
  var addonNames = project.addons.map(function (addon) {
    return addon.name;
  });

  if (blacklist) {
    blacklist.forEach(function (addonName) {
      if (addonNames.indexOf(addonName) === -1) {
        throw new Error(`Addon "${addonName}" defined in blacklist is not found`);
      }
    });
  }

  if (whitelist) {
    whitelist.forEach(function (addonName) {
      if (addonNames.indexOf(addonName) === -1) {
        throw new Error(`Addon "${addonName}" defined in whitelist is not found`);
      }
    });
  }

  project.addons = project.addons.filter(notiferFn);
}