'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getTemplateSpecifier = getTemplateSpecifier;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var path = require('path');
var Filter = require('broccoli-persistent-filter');

var _require = require('@glimmer/compiler'),
    _precompile = _require.precompile;

var extractPragmaPlugin = require('./extract-pragma-ast-transform');

function isFeatureFlagEnabled(features, flagName) {
  return features && !!features[flagName];
}

var GlimmerTemplatePrecompiler = function (_Filter) {
  _inherits(GlimmerTemplatePrecompiler, _Filter);

  function GlimmerTemplatePrecompiler(inputNode, options) {
    _classCallCheck(this, GlimmerTemplatePrecompiler);

    // TODO: enable persistent output

    var _this = _possibleConstructorReturn(this, (GlimmerTemplatePrecompiler.__proto__ || Object.getPrototypeOf(GlimmerTemplatePrecompiler)).call(this, inputNode, { persist: false }));

    _this.extensions = ['hbs'];
    _this.targetExtension = 'ts';
    _this.rootName = options.rootName;
    _this.glimmerEnv = options.GlimmerENV || {};
    _this.plugins = options.plugins || {};
    _this.plugins.ast = _this.plugins.ast || [];

    if (isFeatureFlagEnabled(_this.glimmerEnv.FEATURES, 'glimmer-custom-component-manager')) {
      _this.registerPlugin(extractPragmaPlugin);
    }
    return _this;
  }

  _createClass(GlimmerTemplatePrecompiler, [{
    key: 'registerPlugin',
    value: function registerPlugin(plugin) {
      this.plugins.ast.push(plugin);
    }
  }, {
    key: 'processString',
    value: function processString(content, relativePath) {
      var specifier = getTemplateSpecifier(this.rootName, relativePath);
      var meta = { specifier, managerId: undefined };

      var precompiledContent = this.precompile(content, { meta });

      return `export default ${precompiledContent};`;
    }
  }, {
    key: 'precompile',
    value: function precompile(content, _options) {
      var plugins = this.plugins;
      var options = Object.assign({}, _options, { plugins });

      return _precompile(content, options);
    }
  }]);

  return GlimmerTemplatePrecompiler;
}(Filter);

exports.default = GlimmerTemplatePrecompiler;
function getTemplateSpecifier(rootName, relativePath) {
  var pathParts = relativePath.split('/');
  pathParts.shift();

  // TODO - should use module map config to be rigorous
  if (pathParts[pathParts.length - 1] === 'template.hbs') {
    pathParts.pop();
  }

  if (path.extname(pathParts[pathParts.length - 1]) === '.hbs') {
    var fileName = pathParts.pop();

    pathParts.push(path.basename(fileName, '.hbs'));
  }

  if (pathParts[0] === 'ui') {
    pathParts.shift();
  }

  return `template:/${rootName}/${pathParts.join('/')}`;
}