'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findLib;

var _path = require('path');

function findLib(name, libPath) {
  var packagePath = (0, _path.join)(name, 'package');
  var packageRoot = (0, _path.dirname)(require.resolve(packagePath));

  libPath = libPath || getLibPath(packagePath);

  return (0, _path.resolve)(packageRoot, libPath);
}

function getLibPath(packagePath) {
  var packageJson = require(packagePath);

  return (0, _path.dirname)(packageJson['module'] || packageJson['main']);
}